2 # ipkg - the itsy package management system
4 # Copyright (C) 2001 Carl D. Worth
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2, or (at your option)
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
18 # By default do not do globbing. Any command wanting globbing should
19 # explicitly enable it first and disable it afterwards.
24 sed -ne "s/^src[[:space:]]\+$srcre[[:space:]]\+//p" < $IPKG_CONF
28 sed -ne "s/^src[[:space:]]\+\([^[:space:]]\+\).*/\1/p" < $IPKG_CONF
33 ipkg_srcs
$src |
head -1
37 local destre
="`echo $1 | ipkg_protect_slashes`"
38 sed -ne "/^dest[[:space:]]\+$destre/{
39 s/^dest[[:space:]]\+[^[:space:]]\+[[:space:]]\+//
40 s/^/`echo $IPKG_OFFLINE_ROOT | ipkg_protect_slashes`/
46 sed -ne "s/^dest[[:space:]]\+\([^[:space:]]\+\).*/\1/p" < $IPKG_CONF
54 ipkg_dests_all |
sed "s|\$|/$IPKG_DIR_PREFIX|"
58 ipkg_dests_all |
head -1
61 ipkg_dest_default_name
() {
62 ipkg_dest_names |
head -1
67 ipkg_dests
$dest |
head -1
72 sed -ne "s/^option[[:space:]]\+$option[[:space:]]\+//p" < $IPKG_CONF
75 ipkg_load_configuration
() {
76 if [ -z "$IPKG_CONF_DIR" ]; then
80 IPKG_CONF
="$IPKG_CONF_DIR/ipkg.conf"
82 if [ -z "$IPKG_OFFLINE_ROOT" ]; then
83 IPKG_OFFLINE_ROOT
="`ipkg_option offline_root`"
85 # Export IPKG_OFFLINE_ROOT for use by update-alternatives
86 export IPKG_OFFLINE_ROOT
87 if [ -n "$DEST_NAME" ]; then
88 IPKG_ROOT
="`ipkg_dest_byname $DEST_NAME`"
89 if [ -z "$IPKG_ROOT" ]; then
90 if [ -d "$IPKG_OFFLINE_ROOT$DEST_NAME" ]; then
91 IPKG_ROOT
="$IPKG_OFFLINE_ROOT$DEST_NAME";
93 echo "ipkg: invalid destination specification: $DEST_NAME
94 Valid destinations are directories or one of the dest names from $IPKG_CONF:" >&2
100 IPKG_ROOT
="`ipkg_dest_default`"
103 # Global ipkg state directories
104 IPKG_DIR_PREFIX
=usr
/lib
/ipkg
105 IPKG_LISTS_DIR
=$IPKG_OFFLINE_ROOT/$IPKG_DIR_PREFIX/lists
106 IPKG_PENDING_DIR
=$IPKG_OFFLINE_ROOT/$IPKG_DIR_PREFIX/pending
107 IPKG_TMP
=$IPKG_ROOT/tmp
/ipkg
109 # Destination specific ipkg meta-data directory
110 IPKG_STATE_DIR
=$IPKG_ROOT/$IPKG_DIR_PREFIX
113 IPKG_PROXY_USERNAME
="`ipkg_option proxy_username`"
114 IPKG_PROXY_PASSWORD
="`ipkg_option proxy_password`"
115 IPKG_HTTP_PROXY
="`ipkg_option http_proxy`"
116 IPKG_FTP_PROXY
="`ipkg_option ftp_proxy`"
117 IPKG_NO_PROXY
="`ipkg_option no_proxy`"
118 if [ -n "$IPKG_HTTP_PROXY" ]; then
119 export http_proxy
="$IPKG_HTTP_PROXY"
122 if [ -n "$IPKG_FTP_PROXY" ]; then
123 export ftp_proxy
="$IPKG_FTP_PROXY"
126 if [ -n "$IPKG_NO_PROXY" ]; then
127 export no_proxy
="$IPKG_NO_PROXY"
130 IPKG_STATUS_FIELDS
='\(Package\|Status\|Essential\|Version\|Conffiles\|Root\)'
134 [ $# -gt 0 ] && echo "ipkg: $*"
136 usage: ipkg [options...] sub-command [arguments...]
137 where sub-command is one of:
139 Package Manipulation:
140 update Update list of available packages
141 upgrade Upgrade all installed packages to latest version
142 install <pkg> Download and install <pkg> (and dependencies)
143 install <file.ipk> Install package <file.ipk>
144 install <file.deb> Install package <file.deb>
145 remove <pkg> Remove package <pkg>
147 Informational Commands:
148 list List available packages and descriptions
149 files <pkg> List all files belonging to <pkg>
150 search <file> Search for a packaging providing <file>
151 info [pkg [<field>]] Display all/some info fields for <pkg> or all
152 status [pkg [<field>]] Display all/some status fields for <pkg> or all
153 depends <pkg> Print uninstalled package dependencies for <pkg>
156 -d <dest_name> Use <dest_name> as the the root directory for
157 -dest <dest_name> package installation, removal, upgrading.
158 <dest_name> should be a defined dest name from the
159 configuration file, (but can also be a directory
161 -o <offline_root> Use <offline_root> as the root for offline installation.
162 -offline <offline_root>
164 Force Options (use when ipkg is too smart for its own good):
165 -force-depends Make dependency checks warnings instead of errors
166 -force-defaults Use default options for questions asked by ipkg.
167 (no prompts). Note that this will not prevent
168 package installation scripts from prompting.
174 local dir
="`echo $1 | sed -ne 's/\(.*\/\).*/\1/p'`"
175 if [ -z "$dir" ]; then
182 echo $1 |
sed 's/.*\///'
185 ipkg_protect_slashes
() {
193 local src_file
="`ipkg_file_part $src`"
194 local dest_dir
="`ipkg_dir_part $dest`"
195 if [ -z "$dest_dir" ]; then
199 local dest_file
="`ipkg_file_part $dest`"
200 if [ -z "$dest_file" ]; then
201 dest_file
="$src_file"
206 local proxypassword
=""
209 if [ -n "$IPKG_PROXY_USERNAME" ]; then
210 proxyuser
="--proxy-user=\"$IPKG_PROXY_USERNAME\""
211 proxypassword
="--proxy-passwd=\"$IPKG_PROXY_PASSWORD\""
214 if [ -n "$IPKG_PROXY_HTTP" -o -n "$IPKG_PROXY_FTP" ]; then
215 proxyoption
="--proxy=on"
218 echo "Downloading $src ..."
219 rm -f $IPKG_TMP/$src_file
222 if ! wget
--passive-ftp $proxyoption $proxyuser $proxypassword -P $IPKG_TMP $src; then
223 echo "ipkg_download: ERROR: Failed to retrieve $src, returning $err"
226 mv $IPKG_TMP/$src_file $dest_dir/$dest_file 2>/dev
/null
229 ln -s `echo $src | sed 's/^file://'` $dest_dir/$dest_file 2>/dev
/null
241 if [ ! -e "$IPKG_LISTS_DIR" ]; then
242 mkdir
-p $IPKG_LISTS_DIR
246 for src_name
in `ipkg_src_names`; do
247 local src
="`ipkg_src_byname $src_name`"
248 if ! ipkg_download
$src/Packages
$IPKG_LISTS_DIR/$src_name; then
249 echo "ipkg_update: Error downloading $src/Packages to $IPKG_LISTS_DIR/$src_name" >&2
252 echo "Updated list of available packages in $IPKG_LISTS_DIR/$src_name"
256 [ -n "$err" ] && return 1
262 for src
in `ipkg_src_names`; do
263 if ipkg_require_list
$src; then
267 s/^Package:[[:space:]]*\<\([a-z0-9.+-]*$1[a-z0-9.+-]*\).*/\1/
271 s/^Description:[[:space:]]*\(.*\)/\1/
278 " $IPKG_LISTS_DIR/$src
283 ipkg_extract_paragraph
() {
285 sed -ne "/Package:[[:space:]]*$pkg[[:space:]]*\$/,/^\$/p"
288 ipkg_extract_field
() {
308 ipkg_extract_value
() {
309 sed -e "s/^[^:]*:[[:space:]]*//"
312 ipkg_require_list
() {
313 [ $# -lt 1 ] && return 1
315 if [ ! -f "$IPKG_LISTS_DIR/$src" ]; then
316 echo "ERROR: File not found: $IPKG_LISTS_DIR/$src" >&2
317 echo " You probably want to run \`ipkg update'" >&2
324 for src
in `ipkg_src_names`; do
325 if ipkg_require_list
$src; then
328 cat $IPKG_LISTS_DIR/$src
331 ipkg_extract_paragraph
$1 < $IPKG_LISTS_DIR/$src
334 ipkg_extract_paragraph
$1 < $IPKG_LISTS_DIR/$src | ipkg_extract_field
$2
342 [ $# -lt 1 ] && return 0
345 if [ -f $sd/status
]; then
351 ipkg_extract_paragraph
$1 < $sd/status
354 ipkg_extract_paragraph
$1 < $sd/status | ipkg_extract_field
$2
362 for sd
in `ipkg_state_dirs`; do
363 ipkg_status_sd
$sd $
*
368 if [ -n "$DEST_NAME" ]; then
369 ipkg_status_sd
$IPKG_STATE_DIR $
*
375 ipkg_status_matching_sd
() {
378 if [ -f $sd/status
]; then
382 s/^Package:[[:space:]]*//
401 ipkg_status_matching_all
() {
402 for sd
in `ipkg_state_dirs`; do
403 ipkg_status_matching_sd
$sd $
*
407 ipkg_status_matching
() {
408 if [ -n "$DEST_NAME" ]; then
409 ipkg_status_matching_sd
$IPKG_STATE_DIR $
*
411 ipkg_status_matching_all $
*
415 ipkg_status_installed_sd
() {
418 ipkg_status_sd
$sd $pkg Status |
grep -q "Status: install ok installed"
421 ipkg_status_installed_all
() {
423 for sd
in `ipkg_state_dirs`; do
424 if `ipkg_status_installed_sd $sd $*`; then
431 ipkg_status_mentioned_sd
() {
434 [ -n "`ipkg_status_sd $sd $pkg Status`" ]
439 if [ -n "$DEST_NAME" ]; then
442 dests
="`ipkg_dests_all`"
444 for dest
in $dests; do
445 if [ -f $dest/$IPKG_DIR_PREFIX/info
/$pkg.list
]; then
446 dest_sed
="`echo $dest | ipkg_protect_slashes`"
447 sed -e "s/^/$dest_sed/" < $dest/$IPKG_DIR_PREFIX/info
/$pkg.list
455 for dest_name
in `ipkg_dest_names`; do
456 dest
="`ipkg_dest_byname $dest_name`"
457 dest_sed
="`echo $dest | ipkg_protect_slashes`"
460 local list_files
="`ls -1 $dest/$IPKG_DIR_PREFIX/info/*.list 2>/dev/null`"
462 for file in $list_files; do
463 if sed "s/^/$dest_sed/" $file |
grep -q $pattern; then
464 local pkg
="`echo $file | sed "s
/^.
*\
/\
(.
*\
)\.list
/\
1/"`"
465 [ "$dest_name" != `ipkg_dest_default_name` ] && pkg
="$pkg ($dest_name)"
466 sed "s/^/$dest_sed/" $file |
grep $pattern |
sed "s/^/$pkg: /"
472 ipkg_status_remove_sd
() {
476 if [ ! -f $sd/status
]; then
480 sed -ne "/Package:[[:space:]]*$pkg[[:space:]]*\$/,/^\$/!p" < $sd/status
> $sd/status.new
481 mv $sd/status.new
$sd/status
484 ipkg_status_remove_all
() {
485 for sd
in `ipkg_state_dirs`; do
486 ipkg_status_remove_sd
$sd $
*
490 ipkg_status_remove
() {
491 if [ -n "$DEST_NAME" ]; then
492 ipkg_status_remove_sd
$IPKG_STATE_DIR $
*
494 ipkg_status_remove_all $
*
498 ipkg_status_update_sd
() {
502 ipkg_status_remove_sd
$sd $pkg
503 ipkg_extract_field
"$IPKG_STATUS_FIELDS" >> $sd/status
504 echo "" >> $sd/status
507 ipkg_status_update
() {
508 ipkg_status_update_sd
$IPKG_STATE_DIR $
*
511 ipkg_unsatisfied_dependences
() {
513 local deps
="`ipkg_get_depends $pkg`"
514 local remaining_deps
=
516 local installed
="`ipkg_get_installed $dep`"
517 if [ "$installed" != "installed" ] ; then
518 remaining_deps
="$remaining_deps $dep"
521 ## echo "ipkg_unsatisfied_dependences pkg=$pkg $remaining_deps" > /dev/console
525 ipkg_safe_pkg_name
() {
527 local spkg
="`echo pkg_$pkg | sed -e y/-+./___/`"
534 pkg
="`ipkg_safe_pkg_name $pkg`"
535 ## setvar ${pkg}_depends "$new_deps"
536 echo $new_deps > /tmp
/ipkg
/${pkg}.depends
541 pkg
="`ipkg_safe_pkg_name $pkg`"
542 cat /tmp
/ipkg
/${pkg}.depends
543 ## eval "echo \$${pkg}_depends"
546 ipkg_set_installed
() {
548 pkg
="`ipkg_safe_pkg_name $pkg`"
549 echo installed
> /tmp
/ipkg
/${pkg}.installed
550 ## setvar ${pkg}_installed "installed"
553 ipkg_set_uninstalled
() {
555 pkg
="`ipkg_safe_pkg_name $pkg`"
556 ### echo ipkg_set_uninstalled $pkg > /dev/console
557 echo uninstalled
> /tmp
/ipkg
/${pkg}.installed
558 ## setvar ${pkg}_installed "uninstalled"
561 ipkg_get_installed
() {
563 pkg
="`ipkg_safe_pkg_name $pkg`"
564 if [ -f /tmp
/ipkg
/${pkg}.installed
]; then
565 cat /tmp
/ipkg
/${pkg}.installed
567 ## eval "echo \$${pkg}_installed"
573 local installed_pkgs
="`ipkg_status_matching_all 'Status:.*[[:space:]]installed'`"
574 for pkg
in $installed_pkgs; do
575 ipkg_set_installed
$pkg
577 while [ -n "$new_pkgs" ]; do
578 all_deps
="$all_deps $new_pkgs"
580 for pkg
in $new_pkgs; do
581 if echo $pkg |
grep -q '[^a-z0-9.+-]'; then
582 echo "ipkg_depends: ERROR: Package name $pkg contains illegal characters (should be [a-z0-9.+-])" >&2
585 # TODO: Fix this. For now I am ignoring versions and alternations in dependencies.
586 new_deps
="$new_deps "`ipkg_info $pkg '\(Pre-\)\?Depends' | ipkg_extract_value | sed -e 's/([^)]*)//g
587 s/\(|[[:space:]]*[a-z0-9.+-]\+[[:space:]]*\)\+//g
590 ipkg_set_depends
$pkg $new_deps
593 new_deps
=`echo $new_deps | sed -e 's/[[:space:]]\+/\\
596 local maybe_new_pkgs
=
597 for pkg
in $new_deps; do
598 if ! echo $installed_pkgs |
grep -q "\<$pkg\>"; then
599 maybe_new_pkgs
="$maybe_new_pkgs $pkg"
604 for pkg
in $maybe_new_pkgs; do
605 if ! echo $all_deps |
grep -q "\<$pkg\>"; then
606 if [ -z "`ipkg_info $pkg`" ]; then
607 echo "ipkg_depends: Warning: $pkg mentioned in dependency but no package found in $IPKG_LISTS_DIR" >&2
608 ipkg_set_installed
$pkg
610 new_pkgs
="$new_pkgs $pkg"
611 ipkg_set_uninstalled
$pkg
614 ipkg_set_uninstalled
$pkg
622 ipkg_get_install_dest
() {
625 local sd
=$dest/$IPKG_DIR_PREFIX
626 local info_dir
=$sd/info
628 local requested_pkgs
="$*"
629 local pkgs
="`ipkg_depends $*`"
633 if ! ipkg_status_mentioned_sd
$sd $pkg; then
635 Status: install ok not-installed" | ipkg_status_update_sd
$sd $pkg
638 ## mark the packages that we were directly requested to install as uninstalled
639 for pkg
in $requested_pkgs; do ipkg_set_uninstalled
$pkg; done
642 local pkgs_installed
=0
643 while [ -n "pkgs" ]; do
645 ## echo "pkgs to install: {$pkgs}" > /dev/console
647 curcheck
="`expr $curcheck + 1`"
648 local is_installed
="`ipkg_get_installed $pkg`"
649 if [ "$is_installed" = "installed" ]; then
650 echo "$pkg is installed" > /dev
/console
654 local remaining_deps
="`ipkg_unsatisfied_dependences $pkg`"
655 if [ -n "$remaining_deps" ]; then
656 new_pkgs
="$new_pkgs $pkg"
657 ### echo "Dependences not satisfied for $pkg: $remaining_deps"
658 if [ $curcheck -ne `echo $pkgs|wc -w` ]; then
664 for src
in `ipkg_src_names`; do
665 if ipkg_require_list
$src; then
666 filename
="`ipkg_extract_paragraph $pkg < $IPKG_LISTS_DIR/$src | ipkg_extract_field Filename | ipkg_extract_value`"
667 [ -n "$filename" ] && break
671 if [ -z "$filename" ]; then
672 echo "ipkg_get_install: ERROR: Cannot find package $pkg in $IPKG_LISTS_DIR"
673 echo "ipkg_get_install: Check the spelling and maybe run \`ipkg update'."
674 ipkg_status_remove_sd
$sd $pkg
678 [ -e "$IPKG_TMP" ] || mkdir
-p $IPKG_TMP
681 local tmp_pkg_file
="$IPKG_TMP/"`ipkg_file_part $filename`
682 if ! ipkg_download
`ipkg_src_byname $src`/$filename $tmp_pkg_file; then
683 echo "ipkg_get_install: Perhaps you need to run \`ipkg update'?"
687 if ! ipkg_install_file_dest
$dest $tmp_pkg_file; then
688 echo "ipkg_get_install: ERROR: Failed to install $tmp_pkg_file"
689 echo "ipkg_get_install: I'll leave it there for you to try a manual installation"
693 ipkg_set_installed
$pkg
694 pkgs_installed
="`expr $pkgs_installed + 1`"
697 ### echo "Installed $pkgs_installed package(s) this round"
698 if [ $pkgs_installed -eq 0 ]; then
699 if [ -z "$new_pkgs" ]; then
711 ipkg_get_install_dest
$IPKG_ROOT $
*
714 ipkg_install_file_dest
() {
717 local sd
=$dest/$IPKG_DIR_PREFIX
718 local info_dir
=$sd/info
720 if [ ! -f "$filename" ]; then
721 echo "ipkg_install_file: ERROR: File $filename not found"
725 local pkg
="`ipkg_file_part $filename | sed 's/\([a-z0-9.+-]\+\)_.*/\1/'`"
726 local ext
="`echo $filename | sed 's/.*\.//'`"
727 local pkg_extract_stdout
728 if [ "$ext" = "ipk" ]; then
729 pkg_extract_stdout
="tar -xzOf"
730 elif [ "$ext" = "deb" ]; then
731 pkg_extract_stdout
="ar p"
733 echo "ipkg_install_file: ERROR: File $filename has unknown extension $ext (not .ipk or .deb)"
738 local depends
="`ipkg_depends $pkg | sed -e "s
/\
<$pkg\
>//"`"
740 # Don't worry about deps that are scheduled for installation
742 for dep
in $depends; do
743 if ! ipkg_status_all
$dep |
grep -q 'Status:[[:space:]]install'; then
744 missing_deps
="$missing_deps $dep"
748 if [ ! -z "$missing_deps" ]; then
749 if [ -n "$FORCE_DEPENDS" ]; then
750 echo "ipkg_install_file: Warning: $pkg depends on the following uninstalled programs: $missing_deps"
752 echo "ipkg_install_file: ERROR: $pkg depends on the following uninstalled programs:
754 echo "ipkg_install_file: You may want to use \`ipkg install' to install these."
759 mkdir
-p $IPKG_TMP/$pkg/control
760 mkdir
-p $IPKG_TMP/$pkg/data
763 if ! $pkg_extract_stdout $filename .
/control.
tar.gz |
(cd $IPKG_TMP/$pkg/control
; tar -xzf - ) ; then
764 echo "ipkg_install_file: ERROR unpacking control.tar.gz from $filename"
768 if [ -n "$IPKG_OFFLINE_ROOT" ]; then
769 if grep -q '^InstallsOffline:[[:space:]]*no' $IPKG_TMP/$pkg/control
/control
; then
770 echo "*** Warning: Package $pkg may not be installed in offline mode"
771 echo "*** Warning: Scheduling $filename for pending installation (installing into $IPKG_PENDING_DIR)"
773 Status: install ok pending" | ipkg_status_update_sd
$sd $pkg
774 mkdir
-p $IPKG_PENDING_DIR
775 cp $filename $IPKG_PENDING_DIR
776 rm -r $IPKG_TMP/$pkg/control
777 rm -r $IPKG_TMP/$pkg/data
784 echo -n "Unpacking $pkg..."
786 for file in $IPKG_TMP/$pkg/control
/*; do
787 local base_file
="`ipkg_file_part $file`"
788 mv $file $info_dir/$pkg.
$base_file
791 rm -r $IPKG_TMP/$pkg/control
793 if ! $pkg_extract_stdout $filename .
/data.
tar.gz |
(cd $IPKG_TMP/$pkg/data
; tar -xzf - ) ; then
794 echo "ipkg_install_file: ERROR unpacking data.tar.gz from $filename"
799 echo -n "Configuring $pkg..."
800 export PKG_ROOT
=$dest
801 if [ -x "$info_dir/$pkg.preinst" ]; then
802 if ! $info_dir/$pkg.preinst
install; then
803 echo "$info_dir/$pkg.preinst failed. Aborting installation of $pkg"
804 rm -rf $IPKG_TMP/$pkg/data
810 local old_conffiles
="`ipkg_status_sd $sd $pkg Conffiles | ipkg_extract_value`"
812 if [ -f "$info_dir/$pkg.conffiles" ]; then
813 for conffile
in `cat $info_dir/$pkg.conffiles`; do
814 if [ -f "$dest/$conffile" ] && ! echo " $old_conffiles " |
grep -q " $conffile "`md5sum $dest/$conffile | sed 's/ .*//'`; then
815 local use_maintainers_conffile
=
816 if [ -z "$FORCE_DEFAULTS" ]; then
818 echo -n "Configuration file \`$conffile'
819 ==> File on system created by you or by a script.
820 ==> File also in package provided by package maintainer.
821 What would you like to do about it ? Your options are:
822 Y or I : install the package maintainer's version
823 N or O : keep your currently-installed version
824 D : show the differences between the versions (if diff is installed)
825 The default action is to keep your current version.
826 *** `ipkg_file_part $conffile` (Y/I/N/O/D) [default=N] ? "
829 [YyIi
] |
[Yy
][Ee
][Ss
])
830 use_maintainers_conffile
=t
835 diff -u $dest/$conffile $IPKG_TMP/$pkg/data/$conffile"
836 diff -u $dest/$conffile $IPKG_TMP/$pkg/data
/$conffile || true
837 echo "[Press ENTER to continue]"
846 if [ -n "$use_maintainers_conffile" ]; then
847 local md5sum="`md5sum $IPKG_TMP/$pkg/data/$conffile | sed 's/ .*//'`"
848 new_conffiles
="$new_conffiles $conffile $md5sum"
850 new_conffiles
="$new_conffiles $conffile <custom>"
851 rm $IPKG_TMP/$pkg/data
/$conffile
854 md5sum="`md5sum $IPKG_TMP/$pkg/data/$conffile | sed 's/ .*//'`"
855 new_conffiles
="$new_conffiles $conffile $md5sum"
861 (cd $IPKG_TMP/$pkg/data
/; tar cf
- . |
(cd $owd; cd $dest; tar xf
-))
862 rm -rf $IPKG_TMP/$pkg/data
864 $pkg_extract_stdout $filename .
/data.
tar.gz |
tar tzf
- |
sed -e 's/^\.//' > $info_dir/$pkg.list
866 if [ -x "$info_dir/$pkg.postinst" ]; then
867 $info_dir/$pkg.postinst configure
870 if [ -n "$new_conffiles" ]; then
871 new_conffiles
='Conffiles: '`echo $new_conffiles | ipkg_protect_slashes`
873 local sed_safe_root
="`echo $dest | sed -e "s
/^
${IPKG_OFFLINE_ROOT}//" | ipkg_protect_slashes`"
874 sed -e "s/\(Package:.*\)/\1\\
875 Status: install ok installed\\
876 Root: ${sed_safe_root}\\
877 ${new_conffiles}/" $info_dir/$pkg.control | ipkg_status_update_sd
$sd $pkg
879 rm -f $info_dir/$pkg.control
880 rm -f $info_dir/$pkg.conffiles
881 rm -f $info_dir/$pkg.preinst
882 rm -f $info_dir/$pkg.postinst
887 ipkg_install_file
() {
888 ipkg_install_file_dest
$IPKG_ROOT $
*
893 while [ $# -gt 0 ]; do
899 local tmp_pkg_file
="$IPKG_TMP/"`ipkg_file_part $pkg`
900 if ipkg_download
$pkg $tmp_pkg_file; then
901 ipkg_install_file
$tmp_pkg_file
905 file:/*.ipk |
file://*.deb
)
906 local ipkg_filename
="`echo $pkg|sed 's/^file://'`"
907 ipkg_install_file
$ipkg_filename
910 if [ -f "$pkg" ]; then
911 ipkg_install_file
$pkg
913 echo "File not found $pkg" >&2
917 ipkg_get_install
$pkg || true
923 ipkg_install_pending
() {
924 [ -n "$IPKG_OFFLINE_ROOT" ] && return 0
926 if [ -d "$IPKG_PENDING_DIR" ]; then
928 local pending
="`ls -1d $IPKG_PENDING_DIR/*.ipk 2> /dev/null`" || true
930 if [ -n "$pending" ]; then
931 echo "The following packages in $IPKG_PENDING_DIR will now be installed:"
933 for filename
in $pending; do
934 if ipkg_install_file
$filename; then
943 ipkg_install_wanted
() {
944 local wanted
="`ipkg_status_matching 'Status:[[:space:]]*install.*not-installed'`"
946 if [ -n "$wanted" ]; then
947 echo "The following package were previously requested but have not been installed:"
950 if [ -n "$FORCE_DEFAULTS" ]; then
951 echo "Installing them now."
953 echo -n "Install them now [Y/n] ? "
970 local avail_ver
="`ipkg_info $pkg Version | ipkg_extract_value | head -1`"
973 for dest_name
in `ipkg_dest_names`; do
974 local dest
="`ipkg_dest_byname $dest_name`"
975 local sd
=$dest/$IPKG_DIR_PREFIX
976 local inst_ver
="`ipkg_status_sd $sd $pkg Version | ipkg_extract_value`"
977 if [ -n "$inst_ver" ]; then
980 if [ -z "$avail_ver" ]; then
981 echo "Assuming locally installed package $pkg ($inst_ver) is up to date"
985 if [ "$avail_ver" = "$inst_ver" ]; then
986 echo "Package $pkg ($inst_ver) installed in $dest_name is up to date"
987 elif [ "$avail_ver" -gt "$inst_ver" ]; then
988 echo "Upgrading $pkg ($dest_name) from $inst_ver to $avail_ver"
989 ipkg_get_install_dest
$dest $pkg
991 echo "Not downgrading package $pkg from $inst_ver to $avail_ver"
996 if [ -z "$is_installed" ]; then
997 echo "Package $pkg does not appear to be installed"
1004 if [ $# -lt 1 ]; then
1005 local pkgs
="`ipkg_status_matching 'Status:.*[[:space:]]installed'`"
1010 for pkg
in $pkgs; do
1011 ipkg_upgrade_pkg
$pkg
1015 ipkg_remove_pkg_dest
() {
1018 local sd
=$dest/$IPKG_DIR_PREFIX
1019 local info_dir
=$sd/info
1021 if ! ipkg_status_installed_sd
$sd $pkg; then
1022 echo "ipkg_remove: Package $pkg does not appear to be installed in $dest"
1023 if ipkg_status_mentioned_sd
$sd $pkg; then
1024 echo "Purging mention of $pkg from the ipkg database"
1025 ipkg_status_remove_sd
$sd $pkg
1030 echo "ipkg_remove: Removing $pkg... "
1032 local files
="`cat $info_dir/$pkg.list`"
1034 export PKG_ROOT
=$dest
1035 if [ -x "$info_dir/$pkg.prerm" ]; then
1036 $info_dir/$pkg.prerm remove
1039 local conffiles
="`ipkg_status_sd $sd $pkg Conffiles | ipkg_extract_value`"
1041 local dirs_to_remove
=
1042 for file in $files; do
1043 if [ -d "$dest/$file" ]; then
1044 dirs_to_remove
="$dirs_to_remove $dest/$file"
1046 if echo " $conffiles " |
grep -q " $file "; then
1047 if echo " $conffiles " |
grep -q " $file "`md5sum $dest/$file | sed 's/ .*//'`; then
1056 local removed_a_dir
=t
1057 while [ -n "$removed_a_dir" ]; do
1059 local new_dirs_to_remove
=
1060 for dir
in $dirs_to_remove; do
1061 if rmdir $dir >/dev
/null
2>&1; then
1064 new_dirs_to_remove
="$new_dirs_to_remove $dir"
1067 dirs_to_remove
="$new_dirs_to_remove"
1070 if [ -n "$dirs_to_remove" ]; then
1071 echo "ipkg_remove: Warning: Not removing the following directories since they are not empty:" >&2
1072 echo "$dirs_to_remove" |
sed -e 's/\/[/]\+/\//g' >&2
1075 if [ -x "$info_dir/$pkg.postrm" ]; then
1076 $info_dir/$pkg.postrm remove
1079 ipkg_status_remove_sd
$sd $pkg
1081 rm -f $info_dir/$pkg.
*
1089 for dest
in `ipkg_dests_all`; do
1090 local sd
=$dest/$IPKG_DIR_PREFIX
1091 if ipkg_status_mentioned_sd
$sd $pkg; then
1092 ipkg_remove_pkg_dest
$dest $pkg
1098 while [ $# -gt 0 ]; do
1101 if [ -n "$DEST_NAME" ]; then
1102 ipkg_remove_pkg_dest
$IPKG_ROOT $pkg
1104 ipkg_remove_pkg
$pkg
1114 while [ $# -gt 0 ]; do
1118 [ $# -gt 1 ] || ipkg_usage
"option $arg requires an argument"
1123 [ $# -gt 1 ] || ipkg_usage
"option $arg requires an argument"
1124 IPKG_OFFLINE_ROOT
="$2"
1134 ipkg_usage
"unknown option $arg"
1143 [ $# -lt 1 ] && ipkg_usage
"ipkg must have one sub-command argument"
1147 ipkg_load_configuration
1151 update|upgrade|list|info|status|install_pending
)
1153 install|depends|remove|files|search
)
1154 [ $# -lt 1 ] && ipkg_usage
"ERROR: the \`\`$cmd'' command requires an argument"
1157 echo "ERROR: unknown sub-command \`$cmd'"
1162 # Only install pending if we have an interactive sub-command
1165 ipkg_install_pending
1171 for a
in `ls $IPKG_TMP`; do